/***************************************************************************
 * eqOSG - An example application which uses OpenSceneGraph with Equalizer *
 *                                                                         *
 * Copyright (C) 2008 by Felix Heide                                       *
 * felix.heide@student.uni-siegen.de                                       *
 *                                                                         *
 * Copyright (C) 2008, 2009 by Thomas McGuire                              *
 * thomas.mcguire@student.uni-siegen.de                                    *
 *                                                                         *
 * This program is free software; you can redistribute it and/or           *
 * modify it under the terms of the GNU Lesser General Public              *
 * License as published by the Free Software Foundation; either            *
 * version 2.1 of the License, or (at your option) any later version.      *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * Lesser General Public License for more details.                         *
 *                                                                         *
 * You should have received a copy of the GNU Lesser General Public        *
 * License along with this library; if not, write to the Free Software     *
 * Foundation, Inc., 51 Franklin Street,                                   *
 * Fifth Floor, Boston, MA  02110-1301  USA                                *
 ***************************************************************************/
#ifndef CHANNEL_H
#define CHANNEL_H

#ifdef WIN32
#define EQ_IGNORE_GLEW
#endif

#include <eq/client/channel.h>
#include <osg/Matrix>

class FrameData;
class Pipe;

/**
 * The Channel renders the frames in frameDraw().
 * This is done by querying the pipe for the viewer and then asking the viewer
 * to render the scene.
 */
class Channel : public eq::Channel
{
public:
    Channel( eq::Window* parent );

protected:
    virtual void frameDraw( const uint32_t frameID );
    virtual bool configInit( const uint32_t initID );

    // This function gets the camera position and viewing direction information out of the
    // frame data and sets the view matrix of the camera of the viewer of the pipe based
    // on this information.
    // This view matrix is then also returned.
    osg::Matrix setPlainViewMatrix( const Pipe* frameData ) const;
};

#endif
