/***************************************************************************
 * eqOSG - An example application which uses OpenSceneGraph with Equalizer *
 *                                                                         *
 * Copyright (C) 2008 by Felix Heide                                       *
 * felix.heide@student.uni-siegen.de                                       *
 *                                                                         *
 * Copyright (C) 2008 by Thomas McGuire                                    *
 * thomas.mcguire@student.uni-siegen.de                                    *
 *                                                                         *
 * This program is free software; you can redistribute it and/or           *
 * modify it under the terms of the GNU Lesser General Public              *
 * License as published by the Free Software Foundation; either            *
 * version 2.1 of the License, or (at your option) any later version.      *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * Lesser General Public License for more details.                         *
 *                                                                         *
 * You should have received a copy of the GNU Lesser General Public        *
 * License along with this library; if not, write to the Free Software     *
 * Foundation, Inc., 51 Franklin Street,                                   *
 * Fifth Floor, Boston, MA  02110-1301  USA                                *
 ***************************************************************************/
#ifdef WIN32
#define EQ_IGNORE_GLEW 
#endif
#include <eq/client/channel.h>
#include <eq/client/types.h>

#include "EqViewer.h"

#include <vmmlib/matrix.hpp>
#include <vmmlib/frustum.hpp>

EqViewer::EqViewer()
{
    mContext = new osgViewer::GraphicsWindowEmbedded;
    setThreadingModel(osgViewer::Viewer::SingleThreaded);
}

void EqViewer::setViewport(eq::Channel *channel)
{
    getCamera()->setGraphicsContext( mContext.get() ); 

    //Set the Frustum of the Channel
    const eq::Frustumf& channelfrustum = channel->getFrustum();
    getCamera()->setProjectionMatrixAsFrustum( channelfrustum.left(), channelfrustum.right(),
                                               channelfrustum.bottom(), channelfrustum.top(),
                                               channelfrustum.near_plane(), channelfrustum.far_plane() );

    //Set absolute pixelvalues for Viewport
    const eq::PixelViewport& channelviewport = channel->getPixelViewport();
    getCamera()->setViewport( channelviewport.x,channelviewport.y,
                              channelviewport.w,channelviewport.h );


}
