/***************************************************************************
 * eqOSG - An example application which uses OpenSceneGraph with Equalizer *
 *                                                                         *
 * Copyright (C) 2008, 2009 by Thomas McGuire                              *
 * thomas.mcguire@student.uni-siegen.de                                    *
 *                                                                         *
 * This program is free software; you can redistribute it and/or           *
 * modify it under the terms of the GNU Lesser General Public              *
 * License as published by the Free Software Foundation; either            *
 * version 2.1 of the License, or (at your option) any later version.      *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU       *
 * Lesser General Public License for more details.                         *
 *                                                                         *
 * You should have received a copy of the GNU Lesser General Public        *
 * License along with this library; if not, write to the Free Software     *
 * Foundation, Inc., 51 Franklin Street,                                   *
 * Fifth Floor, Boston, MA  02110-1301  USA                                *
 ***************************************************************************/
#include "FrameData.h"

#include <eq/eq.h>

FrameData::FrameData()
{
    mData.cameraPosition = eq::Vector3f::ZERO;
    mData.cameraPosition.z() += 10.0f;
    mData.cameraLookAtPoint = eq::Vector3f::ZERO;
    mData.cameraUpVector = eq::Vector3f::ZERO;
    mData.angle = 0.0f;
}

eq::net::Object::ChangeType FrameData::getChangeType() const
{
    return INSTANCE;
}

void FrameData::getInstanceData( eq::net::DataOStream& stream )
{
    stream.writeOnce( &mData, sizeof( mData ) );
}

void FrameData::applyInstanceData( eq::net::DataIStream& stream )
{
    memcpy( &mData, stream.getRemainingBuffer(), sizeof( mData ) );
    stream.advanceBuffer( sizeof( mData ) );
}
